*+--------------------------------------------------------------------
*+
*+ Source Module => d:\ALASKA\SHFILE\\GETUNC.PRG
*+
*+    Copyright(C) 1983-2021 by Auge & Ohr
*+
*+    Functions: Function GetUNCPath()
*+
*+    Reformatted by Click! 2.05.38 on Nov-11-2021 at  1:44 am
*+
*+--------------------------------------------------------------------

#include "Common.ch"

#define BIF_RETURNONLYFSDIRS       0x0001
#define BIF_BROWSEFORCOMPUTER      0x1000
#define BIF_BROWSEFORPRINTER       0x2000
#define BIF_BROWSEINCLUDEFILES     0x4000
#define BIF_SHAREABLE              0x8000
#define BIF_RETURNFSANCESTORS      0x0008
#define BIF_BROWSEINCLUDEURLS      0x0080
#define BIF_UAHINT                 0x0100
#define BIF_EDITBOX                0x0010
#define BIF_NEWDIALOGSTYLE         0x0040
#define BIF_NONEWFOLDERBUTTON      0x0200

#define CSIDL_NETWORK              0x0012

*+--------------------------------------------------------------------
*+
*+    Function GetUNCPath()
*+
*+    Called from ( xcm.prg )   2 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetUNCPath( cTitle )

LOCAL cFolder      := ""
LOCAL nHWND
LOCAL nFlags
LOCAL oShell, oFolder, oFolderItem
LOCAL cDisplayName, bOld, nOld

   DEFAULT cTitle TO ""

   nFlags := BIF_NEWDIALOGSTYLE
   nFlags += BIF_NONEWFOLDERBUTTON
   nFlags += BIF_RETURNONLYFSDIRS

   //    nHWND := SetParent():GetHWND()
   nHWND := SetAppWindow() :GetHWND()

   bOld := ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE
      oShell := CreateObject( "Shell.Application" )
      oFolder := oShell:BrowseForFolder( nHWND, cTitle, nFlags, CSIDL_NETWORK )
      IF oFolder != NIL
         oFolderItem := oFolder:Self
         // (Do not convert FS paths)
         nOld := SET( _SET_CHARSET, CHARSET_ANSI )
         cFolder := oFolderItem:Path
         SET( _SET_CHARSET, nOld )

         IF PCOUNT() > 0
            cDisplayName := oFolderItem:Name
            IF SET( _SET_CHARSET ) == CHARSET_OEM
               cDisplayName := ConvToOemCp( cDisplayName )
            ENDIF
         ENDIF
      ENDIF
   END SEQUENCE
   ERRORBLOCK( bOld )

RETURN cFolder

//
//
//

*+ EOF: GETUNC.PRG
